
/*
       . 
   
           ,  
     .   -     ,
       . 

*/

#property copyright "http://dmffx.com"
#property link      "http://dmffx.com"

extern bool    PartClose_ON            =  false;         //    
extern string  Levels                  =  "10/20/5";     //  . ,   10/20/5         10 ,    20     5 .
extern string  Percents                =  "50/25/25";    //   (  "/")   .       .       1.0 ,  50% - 0.5,  25%  1.0 - 0.3   0.2 
extern int     Slippage                =  3;             //     
extern string  s0                      =  "=== Trailing ===";
extern bool    Trailing_ON             =  false;         //  
extern int     TrailingStartProfit     =  30;            //        
extern int     TrailingStopLevel       =  30;            //  
extern int     TrailingStep            =  1;             //  
extern bool    TrailingOnce            =  false;         //       (). 
extern string  s1                      =  "=== Tester ===";
extern bool    TesterBuy               =  false;         //     -   Buy  
extern bool    TesterSell              =  false;         //     -   Sell  



//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+

string    gvp; 
int Lev[];
int Per[];
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init(){

   gvp="PartCloseAndTrailing_"+Symbol()+"_";
   if(IsTesting())gvp=gvp+"t_";
   if(IsDemo())gvp=gvp+"d_";   
   
      if(IsTesting()){
         for(int i=GlobalVariablesTotal()-1;i>=0;i--){
            if(StringFind(GlobalVariableName(i),gvp,0)==0){
               GlobalVariableDel(GlobalVariableName(i));
            }
         }
      }
   
   string tmpArr[];
   
   fSplitStrToStr(Levels,tmpArr,"/");
   ArrayResize(Lev,ArraySize(tmpArr));
   
      for(i=0;i<ArraySize(tmpArr);i++){
         Lev[i]=StrToInteger(tmpArr[i]);      
      }
      for(i=1;i<ArraySize(tmpArr);i++){
         Lev[i]+=Lev[i-1];
      }
   fSplitStrToStr(Percents,tmpArr,"/");
   ArrayResize(Per,ArraySize(tmpArr));
   
      for(i=0;i<ArraySize(tmpArr);i++){
         Per[i]=StrToInteger(tmpArr[i]); 
         Print(Per[i]);     
      }   
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----

      if(IsTesting()){
         for(int i=GlobalVariablesTotal()-1;i>=0;i--){
            if(StringFind(GlobalVariableName(i),gvp,0)==0){
               GlobalVariableDel(GlobalVariableName(i));
            }
         }
      }

   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start(){

   if(IsTesting()){
      if(OrdersTotal()==0){
         if(TesterBuy)OrderSend(Symbol(),OP_BUY,1.0,NormalizeDouble(Ask,Digits),0,NormalizeDouble(Ask-Point*20,Digits),0,NULL,0,0,CLR_NONE);
         if(TesterSell)OrderSend(Symbol(),OP_SELL,1.0,NormalizeDouble(Bid,Digits),0,NormalizeDouble(Bid+Point*20,Digits),0,NULL,0,0,CLR_NONE);
      }
   }

   if(PartClose_ON){
      for(int i=OrdersTotal()-1;i>=0;i--){
         if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)){
            if(OrderSymbol()==Symbol()){
               int ParentTicket=0;
               int oNum=0;
               double oLots=OrderLots();
               ParentTicket=fGetParentTicket(OrderComment());
                  if(ParentTicket!=0){
                     if(GlobalVariableCheck(gvp+ParentTicket+"_Num")){
                        oNum=GlobalVariableGet(gvp+ParentTicket+"_Num")+1;
                     }
                     if(GlobalVariableCheck(gvp+ParentTicket+"_Lots")){
                        oLots=GlobalVariableGet(gvp+ParentTicket+"_Lots");
                     }  
                  }
               GlobalVariableSet(gvp+OrderTicket()+"_Num",oNum);
               GlobalVariableSet(gvp+OrderTicket()+"_Lots",oLots);
               if(oNum>=ArraySize(Lev))oNum=ArraySize(Lev)-1;
               RefreshRates();
                  if(OrderType()==OP_BUY){
                     if(ND(Bid-OrderOpenPrice())>=ND(Point*Lev[oNum])){
                        double LotsClose=fLotsNormalize(Per[oNum]*oLots/100.0); 
                           if(LotsClose>0){
                              LotsClose=MathMin(LotsClose,OrderLots());                           
                                 if(!OrderClose(OrderTicket(),LotsClose,ND(Bid),Slippage,CLR_NONE)){
                                    Print("Close error "+GetLastError());
                                 }
                           }
                     }
                  }
                  if(OrderType()==OP_SELL){
                     if(ND(OrderOpenPrice()-Ask)>=ND(Point*Lev[oNum])){
                        LotsClose=fLotsNormalize(Per[oNum]*oLots/100.0);
                           if(LotsClose>0){
                              LotsClose=MathMin(LotsClose,OrderLots());
                                 if(!OrderClose(OrderTicket(),LotsClose,ND(Ask),Slippage,CLR_NONE)){
                                    Print("Close error "+GetLastError());                         
                                 }
                           }
                     }                  
                  }                  
            }
         }
         else{
            return(0);
         }
      }   
   }
      
   if(Trailing_ON)fUniTrailingStop();  
   
   return(0);
  }
//+------------------------------------------------------------------+

int fGetParentTicket(string aComment){
   int tPos1=StringFind(aComment,"from");
      if(tPos1>=0){
         int tPos2=StringFind(aComment,"#");
            if(tPos2>tPos1){
               return(StrToInteger(StringSubstr(aComment,tPos2+1,StringLen(aComment)-tPos2-1)));
            }
      }
   return(0);   
}

double fLotsNormalize(double aLots){
   aLots-=MarketInfo(Symbol(),MODE_MINLOT);
   aLots/=MarketInfo(Symbol(),MODE_LOTSTEP);
   aLots=MathRound(aLots);
   aLots*=MarketInfo(Symbol(),MODE_LOTSTEP);
   aLots+=MarketInfo(Symbol(),MODE_MINLOT);
   aLots=NormalizeDouble(aLots,2);
   return(aLots);
}

double ND(double v){return(NormalizeDouble(v,Digits));}

int fSplitStrToStr(string aString,string & aArray[],string aDelimiter){
   string tmp_str="";
   string tmp_char="";
   ArrayResize(aArray,0);
      for(int i=0;i<StringLen(aString);i++){
         tmp_char=StringSubstr(aString,i,1);
            if(tmp_char==aDelimiter){
                  if(StringTrimLeft(StringTrimRight(tmp_str))!=""){
                     ArrayResize(aArray,ArraySize(aArray)+1);
                     aArray[ArraySize(aArray)-1]=tmp_str;
                  }
               tmp_str="";
            }
            else{
               if(tmp_char!=" ")tmp_str=tmp_str+tmp_char;
            }
      }
      if(StringTrimLeft(StringTrimRight(tmp_str))!=""){
         ArrayResize(aArray,ArraySize(aArray)+1);
         aArray[ArraySize(aArray)-1]=tmp_str;
      } 
   return(ArraySize(aArray));
}

void fUniTrailingStop(){
   for(int i=0;i<OrdersTotal();i++){
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)){
         if(OrderSymbol()==Symbol()){
            RefreshRates();            
               if(OrderType()==OP_BUY){
                  double tOrderProfit=ND(Bid-OrderOpenPrice());
                     if(tOrderProfit>=ND(Point*TrailingStartProfit)){//  
                        double BeLevel=ND(OrderOpenPrice()+Point*(TrailingStartProfit-TrailingStopLevel));
                           if(TrailingOnce){
                              double slts=BeLevel;
                           }
                           else{
                              if(ND(Bid-Point*TrailingStopLevel)>ND(OrderStopLoss()+Point*TrailingStep-Point)){
                                 slts=MathMax(BeLevel,ND(Bid-Point*TrailingStopLevel));
                              }  
                              else{
                                 slts=BeLevel; 
                              }
                           }
                           if(ND(OrderStopLoss())<slts){
                              if(!OrderModify(OrderTicket(),OrderOpenPrice(),slts,OrderTakeProfit(),0,CLR_NONE)){
                                 int Check=GetLastError();
                                 Print("Trailing BUY "+OrderTicket()+" error "+Check);                           
                              }
                           }
                     }
               }
               if(OrderType()==OP_SELL){     
                  tOrderProfit=ND(OrderOpenPrice()-Ask);
                     if(tOrderProfit>=ND(Point*TrailingStartProfit)){//  
                        BeLevel=ND(OrderOpenPrice()-Point*(TrailingStartProfit-TrailingStopLevel));
                           if(TrailingOnce){
                              slts=BeLevel;
                           }
                           else{
                              if(ND(Ask+Point*TrailingStopLevel)<ND(OrderStopLoss()-Point*TrailingStep+Point) || ND(OrderStopLoss())){
                                 slts=MathMin(BeLevel,ND(Ask+Point*TrailingStopLevel));
                              }
                              else{
                                 slts=BeLevel; 
                              }
                           }
                           if(ND(OrderStopLoss())>slts || ND(OrderStopLoss())==0){
                              if(!OrderModify(OrderTicket(),OrderOpenPrice(),slts,OrderTakeProfit(),0,CLR_NONE)){
                                 Check=GetLastError();
                                 Print("Trailing SELL "+OrderTicket()+" error "+Check);   
                              }
                           }
                     }         
               }
            }
         }
      }
}

